    import java.awt.*;
    import processing.serial.*;   // nainportování knihoven
Serial port;  // iniciazizace proměné pro sériovou linku
PImage screenshot; // promená pro screenshot
   
int R, G,B; // proměné pro ověření spojení ukládá se hodnota prvního okýnka
int[] serialInArray = new int[3];  // proměná pro načtení COM portů
int r,g,b,index,pozicex=0;   // proměné pro vypočet průměrné barvy koýnek
int pixelcolor[][]= new int[16][3]; //[počet diod][RGB] pro uložení RGB hodnot arduinu
boolean firstContact = false; // pro ověrění spojení
int serialCount = 0; // pro ověrění spojení
 
 void setup() {
    size(640,320); // nastaví okno programu na size(výška, šířka)
    printArray(Serial.list());  // zobrazí dostupné com porty
    String portName = Serial.list()[0];    // nastaví COM port který se bude používat
    port = new Serial(this, portName, 9600); // nastevení rychlosti komunikace
}
 
void draw() {
    screenshot();           // makro pro vyfocení obrazovky
    if (screenshot != null) image(screenshot, 0, 0, width, height); //zobrazení vyfocené obrazovky v pozadí
loadPixels();  // načtení pixelů pozadí a jejich barvi
    for (int o=0;o<16;o++) // for cyklus pro vypočítání průměrné hodnoty 16ti okýnek to odpovídá počtu diod na pásku
    { 
    for(int i=0;i<height;i++)
    {
    for(int e=pozicex;e<pozicex+width/16;e++)
    {
    r+=(int(red(pixels[i*width+e]))); // uložení průměrné hodnoty barev v jedné diodě
    g+=(int(green(pixels[i*width+e])));
    b+=(int(blue(pixels[i*width+e])));
    index++;
   
     }
     pixelcolor[o][0]=r/index; // uložení barvy okýnka/diody pro odeslání po sériové lince
     pixelcolor[o][1]=g/index;
     pixelcolor[o][2]=b/index;

}
pozicex+=width/16;  // posunutí výpočtu o další okýnko
index=0;
r=0; // vynulování dočasné proměné pro byrvy
g=0;
b=0;



}
pozicex=0;
   for(int i=0;i<16;i++)     // zobrazení vypočítaných barev na pozadí programu 16 okýnek 50x50 pixelů
   {
   fill(  pixelcolor[i][0], pixelcolor[i][1], pixelcolor[i][2]);
   rect(pozicex,0,width/16,50);
   pozicex+=width/16;

   }
pozicex=0; // vynulování počátečního bodu

}
 
  void screenshot() {       // makro pro zachycení obrázku plochy
    try {
     screenshot = new PImage(new Robot().createScreenCapture(new Rectangle(0, 0, displayWidth,200)));
    } catch (AWTException e) { }
}



   void serialEvent(Serial myPort) {        // makro pro sériovou komunikaci
   
     int inByte = myPort.read();       // načtení kontaktního sinbolu používáme 'A' 
 
      if (firstContact == false) 
      {
       if (inByte == 'A') { 
       println("kontakt");
       myPort.clear();          // vyčištění bufferu portu 
       firstContact = true;     // první kontakt proběhl
       myPort.write('A');       // dotaz na další
      } 
      } 
        else {             // Přidá nejnovější bajt ze sériového portu do pole:
         serialInArray[serialCount] = inByte;
         serialCount++;

         //když máme 3 bytes:
     if (serialCount > 2 ) {      // arduino posílá naspět hodnotu v RGB o prvním okýnku jako ověrění že se přenos povedl
      R = serialInArray[0];
      G = serialInArray[1];
      B = serialInArray[2];

      // vypíše hodnotu v RGB o prvním okýnku načtenou zpětně z arduina (pouze ověření spojení);
      println(R + "   \t" +G+ "\t  " +B);

     
    myPort.write(11); // počteme číslo 11 aby arduino vědělo že má začít ukládat proměné pro pásek
     for(int i=0;i<15;i++) // for cyklus odesílající 16 hodnot pole, které má 3 podpole R=0 G=1 B=2 
     {

      myPort.write(pixelcolor[i][0]); // pošli R
      myPort.write(pixelcolor[i][1]); // pošli G
      myPort.write(pixelcolor[i][2]); // pošli B
     }
 
      serialCount = 0; // vynulovaní pro další příjem dat
     }
     }
}